#include "Socket.h"
#include "Filesys.h"
#include "Parser.h"

void ForkZombieClean (int signo)
{
   if (signo==SIGCHLD)
      {
      while (waitpid(-1, NULL, WNOHANG) > 0) {}
      }
}

int main(int argc, char *argv[])
{
   Socket Server;
   Parser *parse;
   int newprocess;
   char *newbuf;
 
   signal (SIGCHLD, ForkZombieClean);
 
   if (argc!=2)
      {
      printf ("Usage: Server <port number>\n");
      return ERROR;
      }
 
   if ((Server.Create_Server_Socket(atoi(argv[1])))==ERROR)
      {
      printf ("Error using port %d.  Port Busy. Please try another port.\n",atoi(argv[1]));
      return ERROR;
      }

   for (;;)
      { 
      Server.Listen();
      newprocess=fork();
   
      parse = new Parser(&Server);
      if (newprocess==0)  
         {
         Server.CloseServerSocket();
         while (1)
           { /* server client */
             newbuf=Server.Read();
             if ((strcmp(newbuf,""))==0)
                break; /* when client dies, triggers this condition */
             parse->ParseRequest(newbuf); 
           }

         delete parse;
         Server.CloseSpawnSocket();
         exit(0);
         }

      else
         {  /* server */
         Server.CloseSpawnSocket();       
         continue;
         }
      }
   Server.CloseServerSocket();
}
