#include "Filesys.h"

int FileSys::RoomSize(char *roomnumber)
{
   char tok1[13], tok2[4];
   int i=1;

   while(1)
     {
     ReadFile(i);
     if ((strcmp(buf,""))==0 || (strcmp(buf,"-"))==0)
        return 0; 

     strcpy(tok1,strtok(buf," ")); //room number//
     strcpy(tok2,strtok(NULL," ")); //room capacity//
     if ((strcmp(tok1,roomnumber))==0)
        return atoi(tok2);
     i++;
     }
}

int FileSys::DoesUserExist(char *person)
{
   int i=1;
   char *tempbuf, fileuser[9];

   while (1)
      {
      tempbuf=ReadFile(i);
      if ((strcmp(tempbuf,""))==0 || (strcmp(tempbuf, "-"))==0)
         return NO;
   
      strcpy(fileuser,strtok(tempbuf," "));
      if ((strncmp(fileuser,person,strlen(person)))==0)
	 return YES;

      i++;
      }
}

int FileSys::IsRoomBeingUsed(char *room, char *compstr)
{
   FileSys BookRoomFile;
   int i=1;
   char *tempbuf;

   sprintf(filename,"rooms/%s",room);
   BookRoomFile.OpenFile(filename);
   while (1)
      {
      tempbuf=BookRoomFile.ReadFile(i);
      if ((strcmp(tempbuf,""))==0 || (strcmp(tempbuf, "-"))==0)
         {
         BookRoomFile.CloseFile();
         return NO;
         }

      if ((strcmp(tempbuf,compstr))==0)
         {
         BookRoomFile.CloseFile();
         return YES;
         }
      i++;
      }
}

int FileSys::DoesRoomExist(char *rm, int numusers, int year, int month, 
                           int day, int hour, int len)
{
   FileSys BookRoomFile;
   int i=1, j, k, response=1, hourbak=hour;
   char *tok1, *tok2, cstr[14];
  
   while(1)
     {
      ReadFile(i);
      if ((strcmp(buf,""))==0 || (strcmp(buf,"-"))==0)
         return NO; 

      tok1=strtok(buf," "); //room number//
      tok2=strtok(NULL," "); //room capacity//
      if ((strcmp(rm,tok1))==0  && atoi(tok2)>=numusers)
         {       
         for (j=0; j<len; j++)
            {
            sprintf(cstr,"%d.%d.%d.%d",year, month, day, hour++);
            response*=IsRoomBeingUsed(tok1, cstr);
            }
         if (response==NO)
            {
            sprintf(filename,"rooms/%s",rm);
            BookRoomFile.OpenFile(filename);
            for (k=0; k<len; k++)
               {
               sprintf(cstr,"%d.%d.%d.%d",year, month, day, hourbak++);
               BookRoomFile.WriteFile(cstr,0,0);
               }
            BookRoomFile.CloseFile();
            return YES;
            }
         }
      
      i++;
      }
}
   
char *FileSys::SearchRoomListing(int numusers, int year, int month, 
                                 int day, int hour, int len)
{
   FileSys BookRoomFile;
   int i=1, j, k, response=1,hourbak=hour;
   char *tok1, *tok2, cstr[14];

   while(1)
     {
      strcpy(buf,"");
      response=1;
      ReadFile(i);
      if ((strcmp(buf,""))==0 || (strcmp(buf,"-"))==0)
         return "";
      tok1=strtok(buf," "); //room number//
      tok2=strtok(NULL," "); //room capacity//
      if (atoi(tok2)>=numusers)
         {       
         for (j=0; j<len; j++)
            {
            sprintf(cstr,"%d.%d.%d.%d",year, month, day, hour++);
            response*=IsRoomBeingUsed(tok1, cstr);
            }
   
         if (response==NO)
            {
            sprintf(filename,"rooms/%s",tok1);
            BookRoomFile.OpenFile(filename);
            for (k=0; k<len; k++)
               {
               sprintf(cstr,"%d.%d.%d.%d",year, month, day, hourbak++);
               BookRoomFile.WriteFile(cstr,0,0);
               }
            BookRoomFile.CloseFile();
            return tok1; 
            }        
         }
      
      i++;
      }
}

void FileSys::WaitonLock(void)
{
  fd = open (locfile, O_RDWR | O_CREAT, 0666);
  while ((lockf (fd, F_TLOCK, 0))!=0)
     {
     close(fd);
     sleep(1);
     }
}

int FileSys::OpenFile(char *file)
{
  FILE *temp;

  strcpy(filename,file);
  sprintf(locfile,"%s.lock",filename);
  WaitonLock();

  temp=fopen(filename,"a+");
  fclose(temp);
  fp=fopen(filename,"r+");
  
  fflush(fp);
  rewind(fp);
  strcpy(buf,"");
  fgets(buf,BLOCKSIZE,fp);
  if ((strcmp(buf,""))==0)
     {
     fputc('-',fp);
     fputc('\n',fp);
     }  
  return OK;
}

int FileSys::OpenEventFile(char *file)
{
  int i;
  FILE *temp;

  strcpy(filename,file);
  sprintf(locfile,"%s.lock",filename);
  WaitonLock();

  temp=fopen(filename,"a+");
  fclose(temp);
  fp=fopen(filename,"r+");
 
  //check if the file is empty//
  fflush(fp); 
  rewind(fp);
  strcpy(buf,"");
  fgets(buf,BLOCKSIZE,fp);
  if ((strcmp(buf,""))==0)
     {
     for (i=0; i<24; i++)
        {
        fputc('-',fp);
        fputc('\n',fp);
        }         
     }  
  return OK;
}

int FileSys::OpenUserInfoFile(char *file)
{
  int i;
  FILE *temp;

  strcpy(filename,file);
  sprintf(locfile,"%s.lock",filename);
  WaitonLock();

  temp=fopen(filename,"a+");
  fclose(temp);
  fp=fopen(filename,"r+");

  fflush(fp);
  rewind(fp);
  strcpy(buf,"");
  fgets(buf,BLOCKSIZE,fp);
  if ((strcmp(buf,""))==0)
     {
     for (i=0; i<7; i++)
        {
        fputs("<empty>",fp);
        fputc('\n',fp);
        }         
     }  
  return OK;
}

void FileSys::CloseFile(void)
{
  remove(locfile);

  fclose(fp);
  lseek (fd, 0, SEEK_SET);  /* all this...  */
  lockf (fd, F_ULOCK, 0);   /* is not really necessary... */
  close (fd);               /* since close should do it. */
}

/* This function reads a line of text from a file */
char *FileSys::ReadFile(int linenum)
{
   int i=0, j=0;
   char ch;

   fflush(fp);
   rewind(fp);
   strcpy(buf, "");
   while (i!=linenum)
      {
      strcpy(buf,"");
      if ((ch=fgetc(fp))==EOF)
         {
         ungetc(ch,fp);
         return "";
         }
  
      j=0;
      ungetc(ch,fp);
      while(1)
         {
         ch=fgetc(fp); 
         if (ch=='\n')
            break;        
         buf[j++]=ch;
         }
      i++;  
      }
   buf[j]='\0';
   return buf;
}

void FileSys::WriteFile(char *writetxt, int linenum, int lastline)
{
   int i=1;
  
   CreateTempFile();
   if (linenum==0)
      {
      while(1)
         {
         ReadFile(i);
         if ((strcmp(buf,""))==0)
            {
            fputs(writetxt,tempfp);
            fprintf(tempfp,"\n");
            break;
            }
         else if((strcmp(buf,"-"))!=0)
            {
            fputs(buf,tempfp);
            fprintf(tempfp,"\n");
            }
         i++;
         }
      }

   else
      {
      while(i<=lastline)
         {
         ReadFile(i);
         if ((strcmp(buf,""))==0)
            break;
         if (i==linenum)
            fputs(writetxt,tempfp);
         else
            fputs(buf,tempfp);
         fprintf(tempfp,"\n");
         i++;
         }
      }

   CopyTempFile();
}
   
void FileSys::CreateTempFile(void)
{
  sprintf(backup,"%s.bak",filename);
  tempfp=fopen(backup,"w+");
}

char *FileSys::ReadBackup(int linenum)
{
   int i=0, j=0;
   char ch;

   fflush(tempfp);
   rewind(tempfp);
   while (i!=linenum)
      {
      strcpy(buf,"");
      if ((ch=fgetc(tempfp))==EOF)
         {
         ungetc(ch,tempfp);
         return "";
         }
  
      j=0;
      ungetc(ch,tempfp);
      while(1)
         {
         ch=fgetc(tempfp); 
         if (ch=='\n')
            break;        
         buf[j++]=ch;
         }
      i++;  
      }
   buf[j]='\0';
   return buf;
}

void FileSys::CopyTempFile(void)
{
   int i=1;

   fclose(fp);
   remove(filename);

   fp=fopen(filename,"w+");
   while(1)
      {
      ReadBackup(i);
      if ((strcmp(buf,""))==0)
         break;
      fputs(buf,fp);
      fprintf(fp,"\n");
      i++;
      }
   
   fclose(tempfp);
   remove(backup);
}

int FileSys::DeleteNotification(char *notification)
{
   int i=1;
   int flag=-1;
 
   CreateTempFile();
   while(1)
      {
      ReadFile(i);
      if ((strcmp(buf,""))==0)
         break;
      else if ((strncmp(buf,notification,strlen(notification)))==0)
         flag=0;
      else
         {
         fputs(buf,tempfp);
         fprintf(tempfp,"\n");
         }
      i++;
      }

   CopyTempFile();
   return flag;
} 	

void FileSys::DeleteEvent(int linenum)
{
   int i=1;

   CreateTempFile();
   while(1)
      {
      ReadFile(i);
      if ((strcmp(buf,""))==0) 
         break;
      else if (i==linenum)
         fputs("-",tempfp);
      else
         fputs(buf,tempfp);     
      fprintf(tempfp,"\n");
      i++;
      }
   CopyTempFile();
}

void FileSys::DeleteUserInfo(int linenum)
{
   int i=1;

   CreateTempFile();
   while(1)
      {
      ReadFile(i);
      if ((strcmp(buf,""))==0) 
         break;
      else if (i==linenum)
         fputs("<empty>",tempfp);
      else
         fputs(buf,tempfp);     
      fprintf(tempfp,"\n");
      i++;
      }
   CopyTempFile();
}

int FileSys::DeleteRegistry(char *username)
{
   int i=1;
   int flag=0;

   CreateTempFile();
   while(1)
      {
      ReadFile(i);
      if ((strcmp(buf,""))==0) 
         break;
      else if ((strncmp(buf,username,strlen(username)))==0)
         flag=1;
      else
         {
         fputs(buf,tempfp);     
         fprintf(tempfp,"\n");
         }
      i++;
      }
   CopyTempFile();
   return flag;
}

void FileSys::DeleteRoomEvent(char *event)
{
   int i=1;
 
   CreateTempFile();
   while(1)
      {
      ReadFile(i);
      if ((strcmp(buf,""))==0)
         break;
      else if ((strncmp(buf,event,strlen(event)))!=0)
         {
         fputs(buf,tempfp);
         fprintf(tempfp,"\n");
         }
      i++;
      }

   CopyTempFile();
} 	


