#include "Grpscheduler.h"

GrpScheduler::GrpScheduler(Socket *sock, char *caller) 
             : Scheduler(sock, caller)
{
}

void GrpScheduler::CreateAutoMeet(const char *input)
{
   char str[BLOCKSIZE+1], tmem[BLOCKSIZE+1], btmem[BLOCKSIZE+1];
   char otmem[BLOCKSIZE+1];
   char y1[5],m1[3], d1[3], h1[3], y2[5], m2[3], d2[3], h2[3];
   char len[3], roomy[13], totnum[4], garbage[2], qd[257], dd[257]; 
   char eid[23];
   int py, pm, pd, ph;
   char num[4], user[9];
   int exist,i,j;

   strcpy(str,input);
   strcpy(y1,strtok(str, " "));  
   strcpy(m1,strtok(NULL, " "));  
   strcpy(d1,strtok(NULL, " "));  
   strcpy(y2,strtok(NULL, " "));  
   strcpy(m2,strtok(NULL, " "));  
   strcpy(d2,strtok(NULL, " "));  
   strcpy(h1,strtok(NULL, " "));  
   strcpy(h2,strtok(NULL, " "));  
   strcpy(len,strtok(NULL, " "));  
   strcpy(roomy,strtok(NULL, " "));  
   strcpy(totnum,strtok(NULL, " "));  
   strcpy(qd,strtok(NULL, "|"));  
   strcpy(dd,strtok(NULL, "|"));  
   strcpy(dd,strtok(NULL, "|"));  
   strcpy(num,strtok(NULL, " "));
   if (atoi(len)>24)
      { 
      comm->Write("321 Invalid Length. \n");
      FlatFile.CloseFile();   
      return;
      }
      
   strcpy(tmem,"");
   for (i=0; i<atoi(num); i++)
      {
      strcpy(user,strtok(NULL," "));
      sprintf(tmem,"%s%s 0 ", tmem, user);
      }
      
   //Error check usernames involved in meeting//
   //exit if user does not exist//
   strcpy(str,tmem);
   for (i=0; i<atoi(num); i++)
      {
      strcpy(user,strtok(tmem," "));
      strcpy(garbage,strtok(NULL," "));
      if (i!=(atoi(num)-1))
         strcpy(tmem,strtok(NULL,"\n"));

      //Check if user's actually exist//
      BookFile.OpenFile("registry.dat");
      exist=BookFile.DoesUserExist(user);
      BookFile.CloseFile();
       
      if (exist==NO)
         {
         comm->Write("323 Invalid Usernames. \n");
         FlatFile.CloseFile();
         return;
         }
      }
   
   strcpy(otmem,str);  
   strcat(str,username);
   strcat(str," 0");
   strcpy(tmem,str); 
   strcpy(btmem,str);
 
   py=atoi(y1);
   pm=atoi(m1);
   pd=atoi(d1);

   while(1)
      {
      ph=atoi(h1);
      strcpy(tmem,btmem); 
      for (i=0; i<(atoi(num)+1); i++)  
         {
         j=0;
         if (i==0)
            strcpy(user,strtok(tmem," "));
         else
            {
            strcpy(user,strtok(NULL," ")); //get garbage type id// 
            strcpy(user,strtok(NULL," "));
            }

         strcpy(str,"");
         sprintf(path,"%s/%d.%d.%d.events.dat",user,py,pm,pd);
         BookFile.OpenEventFile(path);
         while (1)
            {
            strcpy(str,BookFile.ReadFile(++ph));
            if (str[0]=='-')
               j++;
            else
               j=0; //reset slots in a row that are free//       
             
            if (j==atoi(len)) //got empty area for meeting//
               {
               ph=ph-atoi(len);
               break;
               }

            if (ph>atoi(h2)) //passed second time boundary//
               {
               IncrementDate(&py, &pm, &pd);
               j=0;
               ph=atoi(h1);
               if (py>atoi(y2) || pm>atoi(m2) || pd>atoi(d2))
                  break;
               }     
     
             if (py>atoi(y2) || pm>atoi(m2) || pd>atoi(d2))
               { 
               BookFile.CloseFile();
               comm->Write("204 No suitable Meeting found. \n");
               FlatFile.CloseFile();
               return;
               }
            }
         
         BookFile.CloseFile();
         if (j!=atoi(len))
            break;
         }

      if (j==atoi(len))
         break;
      }

   printf ("%d %d %d %d\n",py,pm,pd,ph);
   sprintf(eid,"%s.%d.%d.%d.%d",username,py,pm,pd,ph);
   comm->Write("100 OK Slot Found at ");
   comm->Write(eid);
   comm->Write(" \n");
   FlatFile.CloseFile();
}

void GrpScheduler::IncrementDate(int *y, int *m, int *d)
{
   (*d)++;

   //check if leap year to handle Feb case//
   if (((*y)%4==0 && (*y)%100!=0) || (*y)%4==0) //yes leap year//
      {
      if ((*d)>29 && (*m)==2)
         {
         (*d)=1;
         (*m)++;
         }
      }
   
   else //not a leap year, Feb has 28 days//
      {
      if ((*d)>28 && (*m)==2)
         {
         (*d)=1;
         (*m)++;
         }
      }

   if ((*d)>31 && ((*m)==1 || (*m)==3 || (*m)==5 || (*m)==7 || (*m)==8 ||  (*m)==10 || (*m)==12))
      {
      (*d)=1;
      (*m)++;
      if ((*m)>12)
	 {
         (*m)=1;
         (*y)++;
         }
      }  
      
   if ((*d)>30 && ((*m)==4 || (*m)==5 || (*m)==9 || (*m)==11))
      {
      (*d)=1;
      (*m)++;
      if ((*m)>12)
	 {
         (*m)=1;
         (*y)++;
         }
       }
}

void GrpScheduler::CreateMeetEvent(const char *input)
{
   char len[3], eid[23], qdesc[257], ddesc[257], roomy[13], num[4];
   char year[5], day[3], month[3], hour[3], user[9], path[101]; 
   char str[BLOCKSIZE+1], tmem[BLOCKSIZE+1], garbage[2], totnum[4];
   int i, currhour, flag=0, exist;

   FlatFile.OpenFile("rooms/listing.dat"); //don't close till done book//
   strcpy(str,input);
   strcpy(eid,strtok(str, " "));  //get eventid//
   strcpy(len,strtok(NULL, " "));  //get len//
   strcpy(roomy,strtok(NULL, " "));  //get room//
   strcpy(totnum,strtok(NULL, " "));  //get total num people for room//
   strcpy(qdesc,strtok(NULL, "|"));  //get quick desc//
   strcpy(ddesc,strtok(NULL, "|"));  //get garbage//
   strcpy(ddesc,strtok(NULL, "|"));  //get detailed desc//
   strcpy(num,strtok(NULL, " "));  //get num people for notification
   if (atoi(len)>24)
      {
      comm->Write("321 Invalid Length. \n");
      FlatFile.CloseFile();
      return;
      }

   strcpy(tmem,"");
   for (i=0; i<atoi(num); i++)
      {
      strcpy(user,strtok(NULL," "));      
      sprintf(tmem,"%s%s 0 ", tmem, user);
      }

   strcpy(str,eid);
   strcpy(user,strtok(str, "."));   //get user
   strcpy(year,strtok(NULL, ".")); 
   strcpy(month,strtok(NULL, ".")); 
   strcpy(day,strtok(NULL, ".")); 
   strcpy(hour,strtok(NULL, " ")); 

   if ((strcmp(user,username))!=0)
      {
      comm->Write("506 Error.  Not authorized to set ");
      comm->Write(user);
      comm->Write(" 's info. \n");
      FlatFile.CloseFile();
      return;
      }

   //Error check usernames involved in meeting// 
   //exit if user does not exist//
   strcpy(str,tmem);
   for (i=0; i<atoi(num); i++)
      {
      strcpy(user,strtok(tmem," "));
      strcpy(garbage,strtok(NULL," "));
      if (i!=(atoi(num)-1))
         strcpy(tmem,strtok(NULL,"\n"));
      
      //Check if user's actually exist//
      BookFile.OpenFile("registry.dat");
      exist=BookFile.DoesUserExist(user);
      BookFile.CloseFile();
         
      if (exist==NO)
         {
         comm->Write("323 Invalid Usernames. \n");
         FlatFile.CloseFile();
         return;            
         }
      }
   strcpy(tmem,str);

   sprintf(str,"%s/%s.%s.%s.events.dat",username,year,month,day);
   BookFile.OpenEventFile(str);
   currhour=atoi(hour);
   strcpy(str,BookFile.ReadFile(atoi(hour)+1));
   if (str[0]!='-')
      {
      comm->Write("508 Error.  Schedule conflict. \n");
      BookFile.CloseFile();
      FlatFile.CloseFile();
      return;
      }

   //if user requested no room//
   if ((strcmp(roomy,"NO_ROOM"))==0)
      {
      sprintf(str,"%s |%s| |%s| NO_ROOM %s %s %s %s",len,qdesc,ddesc,totnum,username,num,tmem);
      BookFile.WriteFile(str,++currhour,24);
      for (i=1; i<atoi(len); i++)
         BookFile.WriteFile(eid,++currhour,24);
      flag=1;   
      }

   //if user requested a room that server assigns//
   else if ((strcmp(roomy,"YES_ROOM"))==0)
     {     
     strcpy(roomy,FindRoom(atoi(totnum), atoi(year), atoi(month),
                           atoi(day), atoi(hour), atoi(len)));
     if ((strcmp(roomy,""))==0)
        comm->Write("340 SORRY NO ROOM FOUND \n");
     else
        {
        sprintf(str,"%s |%s| |%s| %s %s %s %s %s",len,qdesc,ddesc,roomy,totnum,username,num, tmem);
        BookFile.WriteFile(str,++currhour,24);
        for (i=1; i<atoi(len); i++)
           BookFile.WriteFile(eid,++currhour,24);
        flag=1;   
        }  
     }

   //if user specifies a particular room //
   else
     {
     sprintf(str,"%s |%s| |%s| %s %s %s %s %s",len,qdesc,ddesc,roomy,totnum,username,num, tmem);
     i= FlatFile.DoesRoomExist(roomy, atoi(totnum), atoi(year), atoi(month),
                               atoi(day), atoi(hour), atoi(len));
     if (i==YES)
        {
         BookFile.WriteFile(str,++currhour,24);
            for (i=1; i<atoi(len); i++)
         BookFile.WriteFile(eid,++currhour,24);
         flag=1;   
        }

     else 
        {
        comm->Write("341 SORRY ROOM DOES NOT EXIST \n");
        }        
     }      
 
   BookFile.CloseFile();
   if (flag==1) //meeting is a go - send notifications//
      {
      for (i=0; i<atoi(num); i++)
         {
         if (i==0)
            strcpy(user,strtok(tmem," "));      
         else
            {
            strcpy(user,strtok(NULL," "));      
            strcpy(user,strtok(NULL," "));      
            }

         //Send notification to particular person//
         strcpy(str,"");
         sprintf (str, "%s 0 %s |%s|",username, eid, qdesc);
         sprintf(path,"%s/notify.dat",user);
         BookFile.OpenFile(path);
         BookFile.WriteFile(str,0,0);
         BookFile.CloseFile();
         }

      comm->Write("100 OK Notifications sent. Meeting Pending. \n");      
      }
   
   FlatFile.CloseFile();
} 
                   
void GrpScheduler::DeleteMeetEvent(const char *input) 
{
   char eidp[23], eid[23], len[3], roomy[13], num[4], typ[2], desc[257]; 
   char year[5], day[3], month[3], hour[3], user[9]; 
   char str[BLOCKSIZE+1], tmem[BLOCKSIZE+1], tok[BLOCKSIZE+1]; 
   int i, j, currhour;   

   //Parse eventid to get relevant fields//
   FlatFile.OpenFile("rooms/listing.dat"); //don't close till done book// 
   strcpy(str,input);
   strcpy(eidp,strtok(str," "));
   strcpy(desc,strtok(NULL,"|"));
  
   strcpy(eid,eidp);  //eidp is a parse version of event id (same)//
   strcpy(user,strtok(eidp, "."));   //get user
   strcpy(year,strtok(NULL, ".")); 
   strcpy(month,strtok(NULL, ".")); 
   strcpy(day,strtok(NULL, ".")); 
   strcpy(hour,strtok(NULL, " ")); 

   if ((strcmp(user,username))!=0)
      {
      comm->Write("512 Error.  Not authorized to delete event ");
      comm->Write(eid);
      comm->Write(" \n");
      FlatFile.CloseFile();
      return;
      }

   //Get info about the meeting to delete, like length and room //
   sprintf(str,"%s/%s.%s.%s.events.dat",username,year,month,day);
   BookFile.OpenEventFile(str);
   currhour=atoi(hour);
   strcpy(str,BookFile.ReadFile(currhour+1));  
   if (str[0]=='-')
      {
      comm->Write("511 Error.  No existing meeting event scheduled. \n");
      BookFile.CloseFile();
      FlatFile.CloseFile();
      return;
      }

   strcpy(len,strtok(str, " "));   //get len
   strcpy(tok,strtok(NULL, "|"));
   strcpy(tok,strtok(NULL, "|"));
   strcpy(tok,strtok(NULL, "|"));
   strcpy(roomy,strtok(NULL, " "));
   strcpy(tok,strtok(NULL, " "));
   strcpy(num,strtok(NULL, " "));
   strcpy(tmem,strtok(NULL, "\n"));

   //Delete Meet event from creator Event//
   for (i=currhour; i<(currhour+atoi(len)); i++)
      BookFile.DeleteEvent(i+1);
   BookFile.CloseFile();

   //Delete Events from Room//
   sprintf(str,"rooms/%s",roomy);
   BookFile.OpenFile(str);
   for (i=currhour; i<(currhour+atoi(len)); i++)
      {
      sprintf(str,"%s.%s.%s.%d",year,month,day,i);
      BookFile.DeleteRoomEvent(str);      
      }
   BookFile.CloseFile();

   //Delete Event from other meeting members and send notifications//
   for (i=0; i<atoi(num); i++)
     {
     strcpy(user,"");
     strcpy(typ,"");
     if (i==0)
        {
        strcpy(user,strtok(tmem," "));
        strcpy(typ,strtok(NULL," "));
        }
     else
        {
        strcpy(user,strtok(NULL," "));      
        strcpy(typ,strtok(NULL," "));      
        }

     if (atoi(typ)==0 || atoi(typ)==1 || atoi(typ)==4)
        {
        sprintf(str,"%s/%s.%s.%s.events.dat",user,year,month,day);
        BookFile.OpenEventFile(str);
        for (j=atoi(hour);j<24 ;j++)
           {
           strcpy(str,BookFile.ReadFile(j+1));
           if ((strcmp(str,eid))!=0)
              break;
           BookFile.DeleteEvent(j+1);
           }  

        BookFile.CloseFile();    
        sprintf(str,"%s/notify.dat",user);
        BookFile.OpenFile(str);
        sprintf(str,"%s 0 %s",username, eid); //delete request for a meeting//
        BookFile.DeleteNotification(str);
        sprintf(str,"%s 5 %s",username, eid); //delete notify of room change for a meeting//
        BookFile.DeleteNotification(str); 
        sprintf(str,"%s 3 %s %s",username,eid,desc); //send delete notification//
        BookFile.WriteFile(str,0,0);
        BookFile.CloseFile();
        }    
     }
   comm->Write("100 OK Group meeting event deleted. \n"); 
   FlatFile.CloseFile();
}

void GrpScheduler::ModifyMeetEvent(const char *input)
{
   char len[3], eid[23], nroom[13], oroom[13], qd[257], dd[257], num[4];
   char year[5], day[3], month[3], hour[3], user[9],notnum[4]; 
   char str[BLOCKSIZE+1],tmem[BLOCKSIZE+1], typ[2];
   int i, currhour, flag=0, roomsize;   

   FlatFile.OpenFile("rooms/listing.dat"); //don't close till done book//
   strcpy(str,input);
   strcpy(eid,strtok(str, " "));  //get eventid//
   strcpy(nroom,strtok(NULL, " "));  //get new room//
   strcpy(num,strtok(NULL, " "));  //get num people for room//

   strcpy(str,eid);
   strcpy(user,strtok(str, "."));   //get user
   strcpy(year,strtok(NULL, ".")); 
   strcpy(month,strtok(NULL, ".")); 
   strcpy(day,strtok(NULL, ".")); 
   strcpy(hour,strtok(NULL, " ")); 

   if ((strcmp(user,username))!=0)
      {
      comm->Write("510 Error.  Not authorized to set event");
      comm->Write(eid);
      comm->Write(" \n");
      FlatFile.CloseFile();
      return;
      }

   //Get info about current scheduled meeting//
   sprintf(str,"%s/%s.%s.%s.events.dat",username,year,month,day);
   BookFile.OpenEventFile(str);
   currhour=atoi(hour);   
   strcpy(str,BookFile.ReadFile(currhour+1));
   if (str[0]=='-')
      {
      comm->Write("511 Error.  No existing meeting event scheduled. \n");
      FlatFile.CloseFile();
      return;
      }

   strcpy(len,strtok(str, " "));   //get len
   strcpy(qd,strtok(NULL, "|"));
   strcpy(dd,strtok(NULL, "|"));
   strcpy(dd,strtok(NULL, "|"));
   strcpy(oroom,strtok(NULL, " "));
   strcpy(notnum,strtok(NULL, " ")); //this gets old total number meeting//
   strcpy(notnum,strtok(NULL, " ")); //this gets creator - discard it//
   strcpy(notnum,strtok(NULL, " "));
   strcpy(tmem,strtok(NULL,"\n"));

   //now find the new room for meeting and book it//
   //if user requested no room//
   if ((strcmp(nroom,"NO_ROOM"))==0)
      {
      sprintf(str,"%s |%s| |%s| NO_ROOM %s %s %s %s",len,qd,dd,num,username,notnum,tmem);
      BookFile.WriteFile(str,++currhour,24);
      for (i=1; i<atoi(len); i++)
         BookFile.WriteFile(eid,++currhour,24);
      }

   //if user requested a room that server assigns//
   else if ((strcmp(nroom,"YES_ROOM"))==0)
     {     
     strcpy(nroom,FindRoom(atoi(num), atoi(year), atoi(month),
                           atoi(day), atoi(hour), atoi(len)));
     if ((strcmp(nroom,""))==0) 
       {
       comm->Write("SORRY NO ROOM FOUND \n");
       return;       
       }

     else
        {
        sprintf(str,"%s |%s| |%s| %s %s %s %s %s",len,qd,dd,nroom,num,username,notnum,tmem);
        BookFile.WriteFile(str,++currhour,24);
        for (i=1; i<atoi(len); i++)
           BookFile.WriteFile(eid,++currhour,24);
        }  
     }

   //if user specifies a particular room //
   else
     {
     if ((strcmp(oroom, nroom))==0)
        {  //check if old room can handle new capacity//
        roomsize=FlatFile.RoomSize(oroom);
        if (roomsize>=atoi(num))
           flag=2;   
        }

     sprintf(str,"%s |%s| |%s| %s %s %s %s %s",len,qd,dd,nroom,num,username,notnum,tmem);
     i=FlatFile.DoesRoomExist(nroom, atoi(num), atoi(year), atoi(month),
                              atoi(day), atoi(hour), atoi(len));
     if (flag==2 || i==YES)
        {
         BookFile.WriteFile(str,++currhour,24);
            for (i=1; i<atoi(len); i++)
         BookFile.WriteFile(eid,++currhour,24);
        }

     else 
         flag=1;
     }      

   BookFile.CloseFile();
 
   //if everything is ok, free old rooms and notify people of room changes//
   if (flag==0 && (strcmp(oroom,"NO_ROOM"))!=0)  
      {
      //Delete Events from old Room//
      sprintf(str,"rooms/%s",oroom);
      BookFile.OpenFile(str);
      for (i=atoi(hour); i<(atoi(hour)+atoi(len)); i++)
         {
         sprintf(str,"%s.%s.%s.%d",year,month,day,i);
         BookFile.DeleteRoomEvent(str);      
         }
      BookFile.CloseFile();
      }
    
   //Notify users of room change//
   if (flag==0 || flag==2)
      {
      for (i=0; i<atoi(notnum); i++)
        {
        strcpy(user,"");
        strcpy(typ,"");
 
        if (i==0)
           {
           strcpy(user,strtok(tmem," "));
           strcpy(typ,strtok(NULL," "));
           }
        else
           {
           strcpy(user,strtok(NULL," "));      
           strcpy(typ,strtok(NULL," "));      
           }
 
        if (((strcmp(oroom,nroom))!=0) && (atoi(typ)==0 || atoi(typ)==1 
            || atoi(typ)==4))
           {
           sprintf(str,"%s/notify.dat",user);
           BookFile.OpenFile(str);
           sprintf(str,"%s 5 %s |Room changed to %s|",username,eid,nroom); //send room notification//
           BookFile.WriteFile(str,0,0);
           BookFile.CloseFile();
           } 
        }   
       
      comm->Write("100 OK Meeting modified and notifications sent. \n");
      }    
  
   else
      {
      BookFile.CloseFile();
      comm->Write("SORRY NO ROOM FOUND - revert to old \n");
      }

   FlatFile.CloseFile();
}


