// David Tam
// Filename: Login.h
// Description: Header for Login class
// Created Sat. Oct 31, 1998.

#ifndef LOGIN_H
#define LOGIN_H

#include <string.h>
#include <iostream.h>   /* Needed for debugging purposes */

#include "Filesys.h"
#include "Admin.h"

class Login {
  public:
  Login(Socket * socket);
  int enter(char login []);
  int password(char passwd []);
  int newuser(char username[], char passwd[]);
  int changepassword(char oldpasswd[], char newpasswd[]);
  int logout();
  int help();
  int logged;
  char username [9];

  private:
  int retries;
  Socket * socket_object;
};

// NOTES:
// =====
//
// Functions:
// Use enter() to enter the user name.
// Use password() to enter the password.
//
// Variables:
// The following variables are automatically set when the enter() function or
// password() functions have been executed.
// logged=0 if not currently logged in.
// logged=1 if has username was valid.
// logged=2 if password was valid.
// username is set once the user has successfully executed the enter() function.

#endif
