#include "Perscheduler.h"

PerScheduler::PerScheduler(Socket *sock, char *caller) 
             : Scheduler(sock, caller)
{
}

void PerScheduler::CreatePerEvent(const char *input)
{
   char len[3], eid[23], qdesc[257], ddesc[257], roomy[13], num[4];
   char year[5], day[3], month[3], hour[3], user[9]; 
   char str[BLOCKSIZE+1];
   int i, currhour;   

   FlatFile.OpenFile("rooms/listing.dat"); //don't close till done book//
   strcpy(str,input);
   strcpy(eid,strtok(str, " "));  //get eventid//
   strcpy(len,strtok(NULL, " "));  //get len//
   strcpy(roomy,strtok(NULL, " "));  //get room//
   strcpy(num,strtok(NULL, " "));  //get num people for room//
   strcpy(qdesc,strtok(NULL, "|"));  //get quick desc//
   strcpy(ddesc,strtok(NULL, "\0"));  //get detailed desc//

   strcpy(str,eid);
   strcpy(user,strtok(str, "."));   //get user
   strcpy(year,strtok(NULL, ".")); 
   strcpy(month,strtok(NULL, ".")); 
   strcpy(day,strtok(NULL, ".")); 
   strcpy(hour,strtok(NULL, " ")); 

   if (atoi(len)>24)
      {
      comm->Write("321 Invalid Length. \n");
      FlatFile.CloseFile();
      return;
      }
   
   if ((strcmp(user,username))!=0)
      {
      comm->Write("506 Error.  Not authorized to set ");
      comm->Write(user);
      comm->Write(" 's info. \n");
      FlatFile.CloseFile();
      return;
      }

   sprintf(str,"%s/%s.%s.%s.events.dat",username,year,month,day);
   BookFile.OpenEventFile(str);
   currhour=atoi(hour);
   strcpy(str,"");
   strcpy(str,BookFile.ReadFile(atoi(hour)+1));
   if (str[0]!='-')
      {
      comm->Write("508 Error.  Schedule conflict. \n");
      BookFile.CloseFile();
      FlatFile.CloseFile();
      return;
      }
   
   //if user requested no room//
   if ((strcmp(roomy,"NO_ROOM"))==0)
      {
      sprintf(str,"%s |%s|%s NO_ROOM %s %s 0",len,qdesc,ddesc,num,username);
      BookFile.WriteFile(str,++currhour,24);
      for (i=1; i<atoi(len); i++)
         BookFile.WriteFile(eid,++currhour,24);
      comm->Write("100 OK Personal event scheduled. \n");
      }

   //if user requested a room that server assigns//
   else if ((strcmp(roomy,"YES_ROOM"))==0)
     {     
     strcpy(roomy,FindRoom(atoi(num), atoi(year), atoi(month),
                           atoi(day), atoi(hour), atoi(len)));
     if ((strcmp(roomy,""))==0)
        comm->Write("SORRY NO ROOM FOUND \n");
     else
        {
        sprintf(str,"%s |%s|%s %s %s %s 0",len,qdesc,ddesc,roomy,num,username);
        BookFile.WriteFile(str,++currhour,24);
        for (i=1; i<atoi(len); i++)
           BookFile.WriteFile(eid,++currhour,24);
        comm->Write("100 OK Personal event scheduled. \n");
        }  
     }

   //if user specifies a particular room //
   else
     {
     sprintf(str,"%s |%s|%s %s %s %s 0",len,qdesc,ddesc,roomy,num,username);
     i= FlatFile.DoesRoomExist(roomy, atoi(num), atoi(year), atoi(month),
                               atoi(day), atoi(hour), atoi(len));
     if (i==YES)
        {
         BookFile.WriteFile(str,++currhour,24);
         for (i=1; i<atoi(len); i++) 
            BookFile.WriteFile(eid,++currhour,24);
   
         comm->Write("100 OK Personal event scheduled. \n");
        }

     else 
        {
        comm->Write("SORRY ROOM DOES NOT EXIST \n"); /* FILL THIS */
        }        
     }      
 
   BookFile.CloseFile();
   FlatFile.CloseFile();
} 
                   
void PerScheduler::DeletePerEvent(const char *input) 
{

   char eid[23],len[3], tok[BLOCKSIZE+1], roomy[13]; 
   char year[5], day[3], month[3], hour[3], user[9]; 
   char str[BLOCKSIZE+1];
   int i, currhour;   

   //Parse eventid to get relevant fields//
   FlatFile.OpenFile("rooms/listing.dat"); //don't close till done book//
   strcpy(eid,input);
   strcpy(user,strtok(eid, "."));   //get user
   strcpy(year,strtok(NULL, ".")); 
   strcpy(month,strtok(NULL, ".")); 
   strcpy(day,strtok(NULL, ".")); 
   strcpy(hour,strtok(NULL, " ")); 

   if ((strcmp(user,username))!=0)
      {
      comm->Write("512 Error.  Not authorized to delete event ");
      comm->Write(eid);
      comm->Write(" \n");
      FlatFile.CloseFile();
      return;
      }

   //Get info about the meeting to delete, like length and room //
   sprintf(str,"%s/%s.%s.%s.events.dat",username,year,month,day);
   BookFile.OpenEventFile(str);
   currhour=atoi(hour);
   strcpy(str,BookFile.ReadFile(currhour+1));
   if (str[0]=='-')
      {
      comm->Write("509 Error.  No existing personal event scheduled. \n");
      BookFile.CloseFile();
      FlatFile.CloseFile();
      return;
      }

   strcpy(len,strtok(str, " "));   //get len
   strcpy(tok,strtok(NULL, "|"));
   strcpy(tok,strtok(NULL, "|"));
   strcpy(tok,strtok(NULL, "|"));
   strcpy(roomy,strtok(NULL, " "));
   
   //Delete Personal Event//
   for (i=currhour; i<(currhour+atoi(len)); i++)
      BookFile.DeleteEvent(i+1);
   BookFile.CloseFile();

   //Delete Events from Room//
   sprintf(str,"rooms/%s",roomy);
   BookFile.OpenFile(str);
   for (i=currhour; i<(currhour+atoi(len)); i++)
      {
      sprintf(str,"%s.%s.%s.%d",year,month,day,i);
      BookFile.DeleteRoomEvent(str);      
      }
   
   comm->Write("100 OK Personal event deleted. \n");
   BookFile.CloseFile();
   FlatFile.CloseFile();
}

void PerScheduler::ModifyPerEvent(const char *input)
{
   char len[3], eid[23], nroom[13], oroom[13], qd[257], dd[257],num[4];
   char year[5], day[3], month[3], hour[3], user[9]; 
   char str[BLOCKSIZE+1];
   int i, currhour, flag=0, roomsize;   

   FlatFile.OpenFile("rooms/listing.dat"); //don't close till done book//
   strcpy(str,input);
   strcpy(eid,strtok(str, " "));  //get eventid//
   strcpy(nroom,strtok(NULL, " "));  //get room//
   strcpy(num,strtok(NULL, " "));  //get num people for room//

   strcpy(str,eid);
   strcpy(user,strtok(str, "."));   //get user
   strcpy(year,strtok(NULL, ".")); 
   strcpy(month,strtok(NULL, ".")); 
   strcpy(day,strtok(NULL, ".")); 
   strcpy(hour,strtok(NULL, " ")); 

   if ((strcmp(user,username))!=0)
      {
      comm->Write("510 Error.  Not authorized to set event ");
      comm->Write(eid);
      comm->Write(" \n");
      FlatFile.CloseFile();
      return;
      }

   //Get info about current scheduled meeting//
   sprintf(str,"%s/%s.%s.%s.events.dat",username,year,month,day);
   BookFile.OpenEventFile(str);
   currhour=atoi(hour);   
   strcpy(str,BookFile.ReadFile(currhour+1));
   if (str[0]=='-')
      {
      comm->Write("509 Error.  No existing personal event scheduled. \n");
      FlatFile.CloseFile();
      return;
      }

   strcpy(len,strtok(str, " "));   //get len
   strcpy(qd,strtok(NULL, "|"));
   strcpy(dd,strtok(NULL, "|")); //get garbage//
   strcpy(dd,strtok(NULL, "|"));
   strcpy(oroom,strtok(NULL, " ")); //get old room//

   //now find the new room for meeting and book it//
   //if user requested no room//
   if ((strcmp(nroom,"NO_ROOM"))==0)
      {
      sprintf(str,"%s |%s| |%s| NO_ROOM %s %s 0",len,qd,dd,num,username);
      BookFile.WriteFile(str,currhour+1,24);
      }

   //if user requested a room that server assigns//
   else if ((strcmp(nroom,"YES_ROOM"))==0)
     {     
     strcpy(nroom,FindRoom(atoi(num), atoi(year), atoi(month),
                           atoi(day), atoi(hour), atoi(len)));
     if ((strcmp(nroom,""))==0) 
       {
       comm->Write("SORRY NO ROOM FOUND \n");
       BookFile.CloseFile();
       FlatFile.CloseFile();
       return;       
       }

     else
        {
        sprintf(str,"%s |%s| |%s| %s %s %s 0",len,qd,dd,nroom,num,username);
        BookFile.WriteFile(str,currhour+1,24);
        }  
     }

   //if user specifies a particular room //
   else
     {
     if ((strcmp(oroom, nroom))==0)
        {  //check if old room can handle new capacity//
        roomsize=FlatFile.RoomSize(oroom);                   
        if (roomsize>=atoi(num))
           flag=2;
        }

     sprintf(str,"%s |%s| |%s| %s %s %s 0",len,qd,dd,nroom,num,username);
     i= FlatFile.DoesRoomExist(nroom, atoi(num), atoi(year), atoi(month),
                               atoi(day), atoi(hour), atoi(len));
     if (flag==2 || i==YES)
         BookFile.WriteFile(str,currhour+1,24);

     else 
         flag=1;
     }      
 
   BookFile.CloseFile();
   
   //everything is ok, free old rooms//
   if (flag==0 && (strcmp(oroom,"NO_ROOM"))!=0)  
      {
      //Delete Events from old Room//
      sprintf(str,"rooms/%s",oroom);
      BookFile.OpenFile(str);
      for (i=atoi(hour); i<(atoi(hour)+atoi(len)); i++)
         {
         sprintf(str,"%s.%s.%s.%d",year,month,day,i);
         BookFile.DeleteRoomEvent(str);      
         }
      BookFile.CloseFile();
      comm->Write("100 OK Personal event modified. \n");
      }    
   
   else if((strcmp(oroom,nroom))==0)
      {
      BookFile.CloseFile();
      comm->Write("100 OK Personal event modified. \n");
      }
     
   else
      {
      BookFile.CloseFile();
      comm->Write("SORRY NO ROOM FOUND - revert to old \n");  
      }

   FlatFile.CloseFile();
}


