#ifndef SCHEDULER_H
#define SCHEDULER_H

#include <sys/types.h>
#include <sys/stat.h> 
#include <fcntl.h>    
#include <unistd.h>   
#include <string.h>  
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#include "Socket.h"
#include "Filesys.h"

#define OK              0
#define ERROR          -1
#define BLOCKSIZE    4096

class Scheduler
{
   public:
      Scheduler(Socket *, const char *);
 
      int CreateResponse (const char *);
      int DeleteNotification (const char *);
      int SetUserInfo(const char *);
      int SetToDoList(const char *);
      int SetNotes (const char *);
      int SetPrefs(const char *);
      char *FindRoom (int, int, int, int, int, int);
      void SetName(char *);
 
   protected:
      Socket *comm;
      FileSys FlatFile, BookFile;
      char username[9];
      char command[BLOCKSIZE+1];
      char path[101];

   private:
};

#endif 

