#include "Socket.h"

int Socket::Create_Server_Socket(int port)
{
   if ((sock=socket(AF_INET, SOCK_STREAM, 0)) == -1)
      return ERROR;

   memset(&addr,'\0',sizeof(addr));
   addr.sin_family=AF_INET;
   addr.sin_addr.s_addr=htonl(INADDR_ANY);
   addr.sin_port=htons(port);
  
   if (bind(sock, (struct sockaddr *) &addr, sizeof(addr)) == -1)
      return ERROR;

   if (listen(sock,QUEUELEN) == -1)
      return ERROR;

   printf ("Server ONLINE %s at %d\n",inet_ntoa(addr.sin_addr),port);
   Convert();
   return OK;
}

int Socket::Create_Client_Socket(void)
{
   if ((sock=socket(AF_INET, SOCK_STREAM,0)) == -1)
      return ERROR;
   Convert();
   return OK;
}

int Socket::Listen(void)
{
   addrlen=sizeof(addr);
   new_sock= accept(sock, (struct sockaddr *) &addr, &addrlen);
   if (new_sock<0)
      return ERROR;
   printf ("Connection from %s at %d\n",
                     inet_ntoa(addr.sin_addr), ntohs(addr.sin_port));
   ConvertServerSpawn();
   return OK;
}

int Socket::Convert(void)
{
   fp=fdopen(sock, "r+");
   return OK; 
}

int Socket::ConvertServerSpawn(void)
{
   fpspawn=fdopen(new_sock, "r+");
   return OK; 
}

int Socket::Connect(char *hostname, unsigned short port)
{
   struct hostent *host;

   memset(&addr, '\0',sizeof(addr));
   if ((addr.sin_addr.s_addr = inet_addr(hostname)) == INADDR_NONE)
      {
      if ((host = gethostbyname(hostname))==NULL)
         return ERROR;
      addr.sin_family=host->h_addrtype;
      memcpy(&addr.sin_addr.s_addr, host->h_addr, host->h_length);		
      }

   else
      addr.sin_family=AF_INET;
   addr.sin_port=htons(port);	

   if (connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == -1)
      return ERROR;
   return OK;
}

char *Socket::Read(void)
{  
   char ch;
   int i;

   fflush(fpspawn);
   for (i=0; i<BUFSIZE; i++)
      {
      if ((ch=fgetc(fpspawn))==EOF)
         {
         strcpy(buf,"");
         break;
         }
      else if (ch=='\n')
        {
         buf[i]=0; //ascii for null//
         break;
        }

      buf[i]=ch;
      }
   return buf;
}

int Socket::Write(char *str)
{
   unsigned int i;

   fflush(fpspawn); 
   for (i=0; i<(strlen(str)); i++)
      fputc(str[i],fpspawn);
   
   return OK;
}

void Socket::CloseServerSocket(void)
{
   close(sock);
}

void Socket::CloseSpawnSocket(void)
{
   close(new_sock);
}

