#ifndef SOCKET_H
#define SOCKET_H

#include <sys/types.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <netdb.h>
#include <fcntl.h> 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

#ifndef INADDR_NONE
#define INADDR_NONE 0xffffffff
#endif

#define ERROR         -1
#define OK             0
#define QUEUELEN      15  
#define BUFSIZE     4096

class Socket
   {
   public:
      int Create_Server_Socket (int port);
      int Create_Client_Socket (void);
      int Connect (char *hostname, unsigned  short port);
      int Listen (void);
      void CloseServerSocket (void);
      void CloseSpawnSocket (void);
      char *Read (void);
      int Write (char *buf);
 
   protected:
      int Convert (void);
      int ConvertServerSpawn (void);

   private:
      struct sockaddr_in addr;
      int addrlen;
      char buf[BUFSIZE+1];
      int sock, new_sock;
      FILE *fp, *fpspawn;
   };

#endif
