// David Tam
// Filename: LoginAdminTest.cpp
// Description: Testing Login & Admin class
// Created Sat Oct 31, 1998.

#include <iostream.h>
#include "Login.h"
#include "Admin.h"

int main()
{
  // Local variables
  Socket socket_object;
  Login login_object(&socket_object);
  Login login_object2(&socket_object);
  Admin admin_object(&socket_object);
  
  cout << "Testing enter() and password() functions" << endl;
  cout << "----------------------------------------" << endl;
  cout << "Now testing login entry" << endl;
  cout << "Login:testuserZZZ" << endl;
  login_object.enter("testuserZZZZ");
  cout << "Login:testuserYYY" << endl;
  login_object.enter("testuserZZZZ");
  cout << "Login:testuserXXX" << endl;
  login_object.enter("testuserZZZZ");
  cout << "Login:testuserWWW" << endl;
  login_object.enter("testuserZZZZ");
  cout << "Password:wrong" << endl;
  login_object.password("wrong");
  cout << "Password:bad" << endl;
  login_object.password("bad");
  cout << "Password:ohno" << endl;
  login_object.password("ohno");
  cout << "Login:testuser" << endl;
  login_object.enter("testuser");
  cout << "Password:wrong" << endl;
  login_object.password("wrong");
  cout << "Password:bad" << endl;
  login_object.password("bad");
  cout << "Password:ohno" << endl;
  login_object.password("ohno");
  cout << "Password:dontdoit" << endl;
  login_object.password("dontdoit");
  
  cout << endl;
  cout << "Testing newuser('franz','pumpyouup') function" << endl;
  cout << "----------------------------------------" << endl;
  login_object2.newuser("franz","pumpyouup");

  cout << "Turn logged status to 0 (Not logged in)" << endl;
  login_object2.logged=0;

  cout << "newuser('hans','girlyman'):" << endl;
  login_object2.newuser("hans","girlyman");

  cout << "newuser('hans','girlyhan'):" << endl;
  login_object2.newuser("hans","girlyman");

  cout << "newuser('tamda000','hellothere'):" << endl;
  login_object2.newuser("tamda000","hellothere");
  
  cout << "Turn logged status to 1 (Not logged in)" << endl;
  login_object2.logged=1;
  cout << "newuser('hans','girlyman'):" << endl;
  login_object2.newuser("hans","girlyman");

  cout << "Turn logged status to 0 (Not logged in)" << endl;
  login_object2.logged=0;
  cout << "newuser('hans','girlyman'):" << endl;
  login_object2.newuser("hans","girlyman");

   
  cout << "Testing changepassword('dontdoit','yumyum') function" << endl;
  cout << "----------------------------------------" << endl;
  login_object.changepassword("dontdoit","yumyum");

  cout << "changepassword('hellothere','yucky'):" << endl;
  login_object.changepassword("hellothere","yucky");

  cout << "Turn logged status to 0 (Not logged in)" << endl;
  login_object.logged=0;
  cout << "changepassword('yumyum','yucky'):" << endl;
  login_object.changepassword("yumyum","yucky");

  cout << "Turn logged status to 1 (Not logged in)" << endl;
  login_object.logged=1;
  cout << "changepassword('yumyum','yucky'):" << endl;
  login_object.changepassword("yumyum","yucky");


  cout << "Testing logout() function" << endl;
  cout << "--------------------------" << endl;
  cout << "Turn logged status to 2 (Logged in)" << endl;
  login_object.logged=2;
  cout << "logout()" << endl;
  login_object.logout();
  
   cout << "Turn logged status to 0 (Not logged in)" << endl;
  login_object.logged=0;
  cout << "logout()" << endl;
  login_object.logout();
 
  cout << "Turn logged status to 1 (Not logged in)" << endl;
  login_object.logged=1;
  cout << "logout()" << endl;
  login_object.logout();


  cout << "Testing help() function" << endl;
  cout << "--------------------------" << endl;
  login_object.help();

   cout << "Turn logged status to 0 (Not logged in)" << endl;
  login_object.logged=0;
  cout << "help()" << endl;
  login_object.help();
 
  cout << "Turn logged status to 2 (Logged in)" << endl;
  login_object.logged=1;
  cout << "help()" << endl;
  login_object.help();
  
  
  cout << "TESTING OF ADMIN CLASS" << endl;
  cout << "======================" << endl;
  
  cout << "Testing the add() member function" << endl;
  cout << "---------------------------------" << endl;
  cout << "Adding cokem" << endl;
  admin_object.add("cokem", "cokeisit");

  cout << "Adding tsthomer" << endl;
  admin_object.add("tsthomer", "cokeisit");

  cout << "Adding tsthome" << endl;
  admin_object.add("tsthome", "cokeisit");

  cout << "Adding tsthomes" << endl;
  admin_object.add("tsthoms", "cokeisit");

  cout << endl;
  cout << "Testing the changepasswd() member function" << endl;
  cout << "---------------------------------" << endl;
  cout << "changepasswd('billy','bilboe'):" << endl;
  admin_object.changepasswd("billy","bilboe");

  cout << "changepasswd('tamda000','lambda'):" << endl;
  admin_object.changepasswd("tamda000","lambda");

  cout << "changepasswd('franze','booth'):" << endl;
  admin_object.changepasswd("franze","booth");

  cout << "changepasswd('tsthoms','bowie'):" << endl;
  admin_object.changepasswd("tsthoms","bowie");

  cout << "Testing the Delete() member function" << endl;
  cout << "------------------------------------" << endl;
  cout << "Deleting tsthome" << endl;
  admin_object.Delete ("tsthome");

  cout << "Deleting garfield" << endl;
  admin_object.Delete ("garfield");

  cout << "Deleting franz" << endl;
  admin_object.Delete ("franz");

  cout << "Deleting franz again" << endl;
  admin_object.Delete ("franz");

  
  return 0;  
}

// Fake Socket class constructor()
Socket::Socket()
{
}

// Fake Socket class write() member function
int Socket::Write(char * outputcontents)
{
  cout << "OUTPUT TO SOCKET: " << outputcontents << endl;
  return 0;
}
