// David Tam
// Filename: RequestTest.cpp
// Description: Testing Request class
// Created Wed. Oct 21, 1998.
// Modified Fri Oct 23; Sat Oct 24;

#include <iostream.h>
#include "RequestInternal.h"
#include "Request.h"

int main()
{
  // Local variables
  char eventid [22] = "tamda.2000.11.16.15";
  char filecontents [BLOCKSIZE+1] = 
    "2 |This is the quick description that has been manually generated| \
|This is a much longer description that has been manually generated| \
GB251 10 tamda 3 invitee1 3 invitee2 0 invitee3 1";
  Socket socket_object;
  Request request_object(&socket_object);

  cout << endl << "Testing Request class" << endl;
  cout <<         "=====================" << endl;

  cout << "----------------------------------------------------------" << endl;
  cout << "BEGIN -- Testing EventId class" << endl;
  cout << "----------------------------------------------------------" << endl;
  cout << "Want:eventid[22]=tamda.2000.11.16.15" << endl;
  cout << "Have:eventid[22]=" << eventid << endl << endl;
  
  EventId eventid_object;
  cout << "Created an EventId object called eventid_object" << endl;
  cout << "Want:eventid_object.stripped=" << endl;
  cout << "Have:eventid_object.stripped=" << eventid_object.stripped << endl;
  cout << "Want:eventid_object.full="<< endl;
  cout << "Have:eventid_object.full=" << eventid_object.full << endl;
  cout << "Want:eventid_object.hour_char=" << endl;
  cout << "Have:eventid_object.hour_char=" << eventid_object.hour_char << endl;
  cout << "Want:eventid_object.hour_int=0"<< endl;
  cout << "Have:eventid_object.hour_int=" << eventid_object.hour_int << endl
       << endl;
  
  eventid_object.parse(eventid);
  cout << "Testing parse() member function" << endl;
  cout << "-------------------------------" << endl;
  cout << "Called eventid_object.parse(eventid)" << endl;
  cout << "Want:eventid_object.stripped=tamda/2000.11.16.events.dat" << endl;
  cout << "Have:eventid_object.stripped=" << eventid_object.stripped << endl;
  cout << "Want:eventid_object.full=tamda.2000.11.16.15" << endl;
  cout << "Have:eventid_object.full=" << eventid_object.full << endl;
  cout << "Want:eventid_object.hour_char=15" << endl;
  cout << "Have:eventid_object.hour_char=" << eventid_object.hour_char << endl;
  cout << "Want:eventid_object.hour_int=15" << endl;
  cout << "Have:eventid_object.hour_int=" << eventid_object.hour_int << endl
       << endl;
       
  cout << "Testing combine() member function" << endl;
  cout << "---------------------------------" << endl;
  cout << "Called combine(henry,1882,12,29)" << endl;
  eventid_object.combine("henry","1882","12","29");
  cout << "Want:stripped[]=henry/1882.12.29.events.dat" << endl;
  cout << "Have:stripped[]=" << eventid_object.stripped << endl;
  cout << "----------------------------------------------------------" << endl;
  cout << "END -- Testing EventId class" << endl;
  cout << "----------------------------------------------------------" << endl;

  cout << "----------------------------------------------------------" << endl;
  cout << "BEGIN -- Testing (partial) FileContents class" << endl;
  cout << "----------------------------------------------------------" << endl;
  FileContents filecontents_object;
  cout << "Created filecontents_object" << endl;
  cout << "The following variables should be empty, except *_int=0" << endl;
  cout << "Want:filecontents_object.length_char=" << endl;
  cout << "Have:filecontents_object.length_char=" 
       << filecontents_object.length_char << endl;
  cout << "Want:filecontents_object.length_int=0" << endl;
  cout << "Have:filecontents_object.length_int=" 
       << filecontents_object.length_int << endl;
  cout << "Want:filecontents_object.quickdesc=" << endl;
  cout << "Have:filecontents_object.quickdesc=" 
       << filecontents_object.quickdesc << endl;
  cout << "Want:filecontents_object.detaildesc=" << endl;
  cout << "Have:filecontents_object.detaildesc=" 
       << filecontents_object.detaildesc << endl;
  cout << "Want:filecontents_object.room=" << endl;
  cout << "Have:filecontents_object.room=" << filecontents_object.room << endl;
  cout << "Want:filecontents_object.numinroom=" << endl;
  cout << "Have:filecontents_object.numinroom="
       << filecontents_object.numinroom << endl;
  cout << "Want:filecontents_object.creator=" << endl;
  cout << "Have:filecontents_object.creator=" << filecontents_object.creator 
       << endl;
  cout << "Want:filecontents_object.numinvitees_char=" << endl;
  cout << "Have:filecontents_object.numinvitees_char=" 
       << filecontents_object.numinvitees_char << endl;
  cout << "Want:filecontents_object.numinvitees_int=" 
       << filecontents_object.numinvitees_int << endl;
  cout << "Have:filecontents_object.numinvitees_int=" 
       << filecontents_object.numinvitees_int << endl
       << endl;

  cout << "Contents of filecontents[BLOCKSIZE+1] should be" << endl
       << "2 |This is the quick description that has been manually generated| "
       << "|This is a much longer description that has been manually generated| "
       << "GB251 10 tamda 3 invitee1 3 invitee2 0 invitee3 1"
       << endl;
  cout << "filecontents[BLOCKSIZE+1]=" << endl << filecontents << endl << endl;

  cout << "Testing the parse() function" << endl;
  cout << "----------------------------" << endl;
  filecontents_object.parse(filecontents);
  cout << "Called filecontents_object.parse(filecontents)" << endl;
  cout << "Want:filecontents_object.length_char=2" << endl;
  cout << "Have:filecontents_object.length_char="
       << filecontents_object.length_char << endl;
  cout << "Want:filecontents_object.length_int=2" << endl;
  cout << "Have:filecontents_object.length_int="
       << filecontents_object.length_int << endl;
  cout << "Want:filecontents_object.quickdesc=|This is the quick description "
       << "that has been manually generated" << endl;
  cout << "Have:filecontents_object.quickdesc="
       << filecontents_object.quickdesc << endl;
  cout << "Want:filecontents_object.detaildesc=|This is a much longer "
       << "description that has been manually generated|" << endl;
  cout << "Have:filecontents_object.detaildesc="
       << filecontents_object.detaildesc << endl;
  cout << "Want:filecontents_object.room=GB251" << endl;
  cout << "Have:filecontents_object.room="
       << filecontents_object.room << endl;
  cout << "Want:filecontents_object.numinroom=10" << endl;
  cout << "Have:filecontents_object.numinroom="
       << filecontents_object.numinroom << endl;
  cout << "Want:filecontents_object.creator=tamda" << endl;
  cout << "Have:filecontents_object.creator="
       << filecontents_object.creator << endl;
  cout << "Want:filecontents_object.numinvitees_char=3" << endl;
  cout << "Have:filecontents_object.numinvitees_char="
       << filecontents_object.numinvitees_char << endl;
  cout << "Want:filecontents_object.numinvitees_int=3" << endl;
  cout << "Have:filecontents_object.numinvitees_int="
       << filecontents_object.numinvitees_int << endl << endl;
  
  cout << "Testing the aninvitee() function" << endl;
  cout << "--------------------------------" << endl;
  cout << "filecontents[BLOCKSIZE+1]=" << filecontents << endl;
  cout << "aninvitee(invitee1)=" << filecontents_object.aninvitee("invitee1")
       << endl;
  cout << "aninvitee(invitee1)=1" << endl;
  cout << "aninvitee(invitee4)=" << filecontents_object.aninvitee("invitee4")
       << endl;
  cout << "aninvitee(invitee4)=0" << endl;
  cout << "aninvitee(invitee2)=" << filecontents_object.aninvitee("invitee2")
       << endl;
  cout << "aninvitee(invitee2)=1" << endl;
  cout << "aninvitee(gates)=" << filecontents_object.aninvitee("gates")
       << endl;
  cout << "aninvitee(gates)=0" << endl;
       
  cout << "----------------------------------------------------------" << endl;
  cout << "END -- Testing (partial) FileContents class" << endl;
  cout << "----------------------------------------------------------" << endl;

  cout << "----------------------------------------------------------" << endl;
  cout << "BEGIN -- Testing (partial) Request class" << endl;
  cout << "----------------------------------------------------------" << endl;
  cout << "Testing quickhourinfo('testuser.1999.10.31.05') member function"
       << endl;
  cout << "---------------------------------------------------------------"
       << endl;
  request_object.quickhourinfo("testuser.1999.10.31.05");
  cout << "Should get:" << endl 
       << "100 OK tamda000 5 |Meeting with boss| \n" << endl;

  cout << endl;
  cout << "Testing the detailedhourinfo(tamda000,ignore.2024.12.25.10) function"
       << endl;
  cout << "--------------------------------------------------------------------"
       << endl;
  request_object.detailedhourinfo("tamda000","testusr2.2024.12.25.10");
  cout << "Should get:" << endl << "100 OK 5 |Meeting with boss| |Boss and I "
       << "gotta talk about my raise| WB316 13 testusr2 2 boss1 3 boss2 1 \n"
       << endl << endl;

  cout << "Calling detailedhourinfo(billy,testusr2.2024.12.25.10) function"
       << endl;
  request_object.detailedhourinfo("billy","testusr2.2024.12.25.10");
  cout << "Should get:" << endl << "505 Error.  Not authorized to look at "
       << "testusr2's schedule." << endl << endl;

  cout << "Calling detailedhourinfo(boss1,testusr2.2024.12.25.10) function"
       << endl;
  request_object.detailedhourinfo("boss1","testusr2.2024.12.25.10");
  cout << "Should get:" << endl << "100 OK 5 |Meeting with boss| |Boss and I "
       << "gotta talk about my raise| WB316 13 testusr2 2 boss1 3 boss2 1 \n"
       << endl << endl;

  cout << "Calling detailedhourinfo(mary,testusr2.2024.12.25.10) function"
       << endl;
  request_object.detailedhourinfo("mary","testusr2.2024.12.25.10");
  cout << "Should get:" << endl << "505 Error.  Not authorized to look at "
       << "testusr2's schedule." << endl << endl;

  cout << "Calling detailedhourinfo(boss2,testusr2.2024.12.25.10) function"
       << endl;
  request_object.detailedhourinfo("boss2","testusr2.2024.12.25.10");
  cout << "Should get:" << endl << "100 OK 5 |Meeting with boss| |Boss and I "
       << "gotta talk about my raise| WB316 13 testusr2 2 boss1 3 boss2 1 \n"
       << endl << endl;

  cout << "Calling detailedhourinfo(boss1,testusr2.2024.12.25.10) function"
       << endl;
  request_object.detailedhourinfo("boss1","testusr2.2024.12.25.10");
  cout << "Should get:" << endl << "100 OK 5 |Meeting with boss| |Boss and I "
       << "gotta talk about my raise| WB316 13 testusr2 2 boss1 3 boss2 1 \n"
       << endl << endl;


  cout << "Testing the infoday() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling infoday(tsthomer,2023,06,17)" << endl;
  request_object.infoday("tsthomer","2023","06","17");
  cout << endl;


  cout << "Testing the calendar() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling calendar(2000,02)" << endl;
  request_object.calendar("2000","02");
  cout << "Should get:" << endl;
  cout << "100 OK 2 2" << endl << endl;
  cout << "Calling calendar(2003,12)" << endl;
  request_object.calendar("2003","12");
  cout << "Should get:" << endl;
  cout << "100 OK 1 3" << endl << endl;
  cout << "Calling calendar(2099,03)" << endl;
  request_object.calendar("2099","03");
  cout << "Should get:" << endl;
  cout << "100 OK 0 2" << endl << endl;

  cout << "Testing the infomonth() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling infomonth(testuser,2000,02)" << endl;
  request_object.infomonth("testuser","2000","02");

  cout << "Testing userinfo() function " << endl;
  cout << "------------------------------" << endl;
  cout << "Calling userinfo(testusr2,0)" << endl;
  request_object.userinfo("testusr2","0");

  cout << "Testing the notification() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling notification(tamda000)" << endl;
  request_object.notification("tamda000");

  cout << "Testing the notes() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling notes(tsthomer,2023,06,17)" << endl;
  request_object.notes("tsthomer","2023","06","17");

  cout << "Testing the todolist() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling todolist(tsthomer,2023,06,17)" << endl;
  request_object.todolist("tsthomer","2023","06","17");

  cout << "Testing the userlist() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling userlist()" << endl;
  request_object.userlist();

  cout << "Testing the roomlist() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling roomlist()" << endl;
  request_object.roomlist();

  cout << "Testing the prefs() function" << endl;
  cout << "------------------------------" << endl;
  cout << "Calling prefs(tsthomer)" << endl;
  request_object.prefs("tsthomer");

  cout << "----------------------------------------------------------" << endl;
  cout << "END -- Testing (partial) Request class" << endl;
  cout << "----------------------------------------------------------" << endl;

  return 0;
}

// Fake Socket class constructor()
Socket::Socket()
{
}

// Fake Socket class write() member function
int Socket::Write(char * outputcontents)
{
  cout << "OUTPUT TO SOCKET: " << outputcontents << endl;
  return 0;
}
