#include "Socket.h"
#include "Filesys.h"

void ForkZombieClean (int signo)
{
   if (signo==SIGCHLD)
      {
      while (waitpid(-1, NULL, WNOHANG) > 0) {}
      }
}

int main(int argc, char *argv[])
{
   Socket Server;
   int newprocess;
   char *newbuf;
 
   signal (SIGCHLD, ForkZombieClean);
 
   if (argc!=2)
      {
      printf ("Usage: Server <port number>\n");
      return ERROR;
      }
 
   Server.Create_Server_Socket(atoi(argv[1]));
   for (;;)
      { 
      Server.Listen();
      newprocess=fork();
   
      if (newprocess==0)  
         {
         Server.CloseServerSocket();
         while (1)
           { /* server client */
           newbuf=Server.Read();
             if ((strcmp(newbuf,""))==0)
                break; /* when client dies, triggers this condition */
             printf("Got: %s\n",newbuf);
             Server.Write(newbuf);
             sleep(1);
           }

         Server.CloseSpawnSocket();
         exit(0);
         }
      else
         {  /* server */
         Server.CloseSpawnSocket();       
         continue;
         }
      }
   Server.CloseServerSocket();
}
